package com.zt.plat.module.qms.business.config.service;

import cn.hutool.core.collection.CollUtil;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigAssayMethodProjectParameterPageReqVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigAssayMethodProjectParameterRespVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigAssayMethodProjectParameterSaveReqVO;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigAssayMethodProjectParameterDO;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.util.object.BeanUtils;

import com.zt.plat.module.qms.business.config.dal.mapper.ConfigAssayMethodProjectParameterMapper;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.module.qms.enums.ErrorCodeConstants.CONFIG_ASSAY_METHOD_PROJECT_PARAMETER_NOT_EXISTS;

/**
 * 检测方法分析项目参数配置 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
public class ConfigAssayMethodProjectParameterServiceImpl implements ConfigAssayMethodProjectParameterService {

    @Resource
    private ConfigAssayMethodProjectParameterMapper configAssayMethodProjectParameterMapper;

    @Override
    public ConfigAssayMethodProjectParameterRespVO createConfigAssayMethodProjectParameter(ConfigAssayMethodProjectParameterSaveReqVO createReqVO) {
        // 插入
        ConfigAssayMethodProjectParameterDO configAssayMethodProjectParameter = BeanUtils.toBean(createReqVO, ConfigAssayMethodProjectParameterDO.class);
        configAssayMethodProjectParameterMapper.insert(configAssayMethodProjectParameter);
        // 返回
        return BeanUtils.toBean(configAssayMethodProjectParameter, ConfigAssayMethodProjectParameterRespVO.class);
    }

    @Override
    public void updateConfigAssayMethodProjectParameter(ConfigAssayMethodProjectParameterSaveReqVO updateReqVO) {
        // 校验存在
        validateConfigAssayMethodProjectParameterExists(updateReqVO.getId());
        // 更新
        ConfigAssayMethodProjectParameterDO updateObj = BeanUtils.toBean(updateReqVO, ConfigAssayMethodProjectParameterDO.class);
        configAssayMethodProjectParameterMapper.updateById(updateObj);
    }

    @Override
    public void deleteConfigAssayMethodProjectParameter(Long id) {
        // 校验存在
        validateConfigAssayMethodProjectParameterExists(id);
        // 删除
        configAssayMethodProjectParameterMapper.deleteById(id);
    }

    @Override
        public void deleteConfigAssayMethodProjectParameterListByIds(List<Long> ids) {
        // 校验存在
        validateConfigAssayMethodProjectParameterExists(ids);
        // 删除
        configAssayMethodProjectParameterMapper.deleteByIds(ids);
        }

    private void validateConfigAssayMethodProjectParameterExists(List<Long> ids) {
        List<ConfigAssayMethodProjectParameterDO> list = configAssayMethodProjectParameterMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(CONFIG_ASSAY_METHOD_PROJECT_PARAMETER_NOT_EXISTS);
        }
    }

    private void validateConfigAssayMethodProjectParameterExists(Long id) {
        if (configAssayMethodProjectParameterMapper.selectById(id) == null) {
            throw exception(CONFIG_ASSAY_METHOD_PROJECT_PARAMETER_NOT_EXISTS);
        }
    }

    @Override
    public ConfigAssayMethodProjectParameterDO getConfigAssayMethodProjectParameter(Long id) {
        return configAssayMethodProjectParameterMapper.selectById(id);
    }

    @Override
    public PageResult<ConfigAssayMethodProjectParameterDO> getConfigAssayMethodProjectParameterPage(ConfigAssayMethodProjectParameterPageReqVO pageReqVO) {
        return configAssayMethodProjectParameterMapper.selectPage(pageReqVO);
    }

}